*** a/src/backend/access/transam/xact.c
--- b/src/backend/access/transam/xact.c
***************
*** 123,129 **** typedef enum TBlockState
  	TBLOCK_SUBABORT_END,		/* failed subxact, ROLLBACK received */
  	TBLOCK_SUBABORT_PENDING,	/* live subxact, ROLLBACK received */
  	TBLOCK_SUBRESTART,			/* live subxact, ROLLBACK TO received */
! 	TBLOCK_SUBABORT_RESTART		/* failed subxact, ROLLBACK TO received */
  } TBlockState;
  
  /*
--- 123,137 ----
  	TBLOCK_SUBABORT_END,		/* failed subxact, ROLLBACK received */
  	TBLOCK_SUBABORT_PENDING,	/* live subxact, ROLLBACK received */
  	TBLOCK_SUBRESTART,			/* live subxact, ROLLBACK TO received */
! 	TBLOCK_SUBABORT_RESTART,	/* failed subxact, ROLLBACK TO received */
! 
! 	TBLOCK_AUTOBEGIN,
! 	TBLOCK_AUTOINPROGRESS,
! 	TBLOCK_AUTOCOMMIT,
! 	TBLOCK_AUTOABORT,
! 	TBLOCK_AUTOABORT_END,
! 	TBLOCK_AUTOABORT_PENDING
! 
  } TBlockState;
  
  /*
***************
*** 149,154 **** typedef struct TransactionStateData
--- 157,164 ----
  	bool		prevXactReadOnly;		/* entry-time xact r/o state */
  	bool		startedInRecovery;		/* did we start in recovery? */
  	bool		didLogXid;		/* has xid been included in WAL record? */
+ 	MemoryContext preMemoryContext; /* previous memory context */
+ 	ResourceOwner preResourceOwner; /* previous resource owner */
  	struct TransactionStateData *parent;		/* back link to parent */
  } TransactionStateData;
  
***************
*** 279,285 **** static void StartSubTransaction(void);
  static void CommitSubTransaction(void);
  static void AbortSubTransaction(void);
  static void CleanupSubTransaction(void);
! static void PushTransaction(void);
  static void PopTransaction(void);
  
  static void AtSubAbort_Memory(void);
--- 289,296 ----
  static void CommitSubTransaction(void);
  static void AbortSubTransaction(void);
  static void CleanupSubTransaction(void);
! static void PushTransaction(bool isAutoTX);
! static TransactionId GetTopAutonomousTransactionID(void);
  static void PopTransaction(void);
  
  static void AtSubAbort_Memory(void);
***************
*** 332,338 **** IsAbortedTransactionBlockState(void)
  	TransactionState s = CurrentTransactionState;
  
  	if (s->blockState == TBLOCK_ABORT ||
! 		s->blockState == TBLOCK_SUBABORT)
  		return true;
  
  	return false;
--- 343,350 ----
  	TransactionState s = CurrentTransactionState;
  
  	if (s->blockState == TBLOCK_ABORT ||
! 		s->blockState == TBLOCK_SUBABORT ||
! 		s->blockState == TBLOCK_AUTOABORT)
  		return true;
  
  	return false;
***************
*** 348,354 **** IsAbortedTransactionBlockState(void)
  TransactionId
  GetTopTransactionId(void)
  {
! 	if (!TransactionIdIsValid(TopTransactionStateData.transactionId))
  		AssignTransactionId(&TopTransactionStateData);
  	return TopTransactionStateData.transactionId;
  }
--- 360,370 ----
  TransactionId
  GetTopTransactionId(void)
  {
! 	if (MyProc->inAutoTXLevel)
! 	{
! 		return GetTopAutonomousTransactionID();
! 	}
! 	else if (!TransactionIdIsValid(TopTransactionStateData.transactionId))
  		AssignTransactionId(&TopTransactionStateData);
  	return TopTransactionStateData.transactionId;
  }
***************
*** 363,368 **** GetTopTransactionId(void)
--- 379,402 ----
  TransactionId
  GetTopTransactionIdIfAny(void)
  {
+ 	if ((MyProc != NULL) && (MyProc->inAutoTXLevel)
+ 							&& (MyPgAutonomousXact != NULL))
+ 	{
+ 		TransactionId result = InvalidTransactionId;
+ 		TransactionState s = CurrentTransactionState;
+ 		TransactionState target = s;
+ 
+ 		for (;PointerIsValid(target) ; target=target->parent)
+ 		{
+ 		 	if (IS_TOP_AUTO_TX_STATE(target))
+ 		 	{
+ 				result = target->transactionId;
+ 				break;
+ 		 	}
+ 		}
+ 		return result;
+ 	}
+ 
  	return TopTransactionStateData.transactionId;
  }
  
***************
*** 451,461 **** AssignTransactionId(TransactionState s)
--- 485,515 ----
  	bool		isSubXact = (s->parent != NULL);
  	ResourceOwner currentOwner;
  	bool log_unknown_top = false;
+ 	int			autotxlevel = 0;
+ 	bool		inAutoTx = false;
+ 	PGAutonomousXACT	*currentautotx = NULL;
+ 	int 		i = 0;
+ 
  
  	/* Assert that caller didn't screw up */
  	Assert(!TransactionIdIsValid(s->transactionId));
  	Assert(s->state == TRANS_INPROGRESS);
  
+ 
+ 	for (i=0; i < MyProc->inAutoTXLevel; i++)
+ 	{
+ 		currentautotx = &MyPgAutonomousXact[i];
+ 		if (currentautotx->nestingLevel <= s->nestingLevel)
+ 		{
+ 			autotxlevel = i+1;
+ 			if (currentautotx->nestingLevel == s->nestingLevel)
+ 			{
+ 				inAutoTx = true;
+ 				break;
+ 			}
+ 		}
+ 	}
+ 
  	/*
  	 * Ensure parent(s) have XIDs, so that a child always has an XID later
  	 * than its parent.  Musn't recurse here, or we might get a stack overflow
***************
*** 507,515 **** AssignTransactionId(TransactionState s)
  	 * PG_PROC, the subtrans entry is needed to ensure that other backends see
  	 * the Xid as "running".  See GetNewTransactionId.
  	 */
! 	s->transactionId = GetNewTransactionId(isSubXact);
  
! 	if (isSubXact)
  		SubTransSetParent(s->transactionId, s->parent->transactionId, false);
  
  	/*
--- 561,569 ----
  	 * PG_PROC, the subtrans entry is needed to ensure that other backends see
  	 * the Xid as "running".  See GetNewTransactionId.
  	 */
! 	s->transactionId = GetNewTransactionId(isSubXact, s->nestingLevel, autotxlevel);
  
! 	if (isSubXact && inAutoTx)
  		SubTransSetParent(s->transactionId, s->parent->transactionId, false);
  
  	/*
***************
*** 749,759 **** TransactionIdIsCurrentTransactionId(TransactionId xid)
  	{
  		int			low,
  					high;
  
  		if (s->state == TRANS_ABORT)
! 			continue;
  		if (!TransactionIdIsValid(s->transactionId))
! 			continue;			/* it can't have any child XIDs either */
  		if (TransactionIdEquals(xid, s->transactionId))
  			return true;
  		/* As the childXids array is ordered, we can use binary search */
--- 803,826 ----
  	{
  		int			low,
  					high;
+ 		int 		isTopAutoTx = IS_TOP_AUTO_TX_STATE(s);
  
  		if (s->state == TRANS_ABORT)
! 		{
! 			if (isTopAutoTx)
! 				break;
! 			else
! 				continue;
! 		}
! 
  		if (!TransactionIdIsValid(s->transactionId))
! 		{
! 			if (isTopAutoTx)
! 				break;
! 			else
! 				continue;			/* it can't have any child XIDs either */
! 		}
! 
  		if (TransactionIdEquals(xid, s->transactionId))
  			return true;
  		/* As the childXids array is ordered, we can use binary search */
***************
*** 773,778 **** TransactionIdIsCurrentTransactionId(TransactionId xid)
--- 840,852 ----
  			else
  				high = middle - 1;
  		}
+ 
+ 		/*
+ 		 * If it was auto-tx and till now it did not match, then no need to
+ 		 * search further.
+ 		 */
+ 		if (isTopAutoTx)
+ 			break;
  	}
  
  	return false;
***************
*** 992,998 **** AtSubStart_ResourceOwner(void)
   * if the xact has no XID.	(We compute that here just because it's easier.)
   */
  static TransactionId
! RecordTransactionCommit(void)
  {
  	TransactionId xid = GetTopTransactionIdIfAny();
  	bool		markXidCommitted = TransactionIdIsValid(xid);
--- 1066,1072 ----
   * if the xact has no XID.	(We compute that here just because it's easier.)
   */
  static TransactionId
! RecordTransactionCommit(bool isAutoXact)
  {
  	TransactionId xid = GetTopTransactionIdIfAny();
  	bool		markXidCommitted = TransactionIdIsValid(xid);
***************
*** 1005,1017 **** RecordTransactionCommit(void)
  	SharedInvalidationMessage *invalMessages = NULL;
  	bool		RelcacheInitFileInval = false;
  	bool		wrote_xlog;
  
  	/* Get data needed for commit record */
  	nrels = smgrGetPendingDeletes(true, &rels);
  	nchildren = xactGetCommittedChildren(&children);
  	if (XLogStandbyInfoActive())
  		nmsgs = xactGetCommittedInvalidationMessages(&invalMessages,
! 													 &RelcacheInitFileInval);
  	wrote_xlog = (XactLastRecEnd != 0);
  
  	/*
--- 1079,1094 ----
  	SharedInvalidationMessage *invalMessages = NULL;
  	bool		RelcacheInitFileInval = false;
  	bool		wrote_xlog;
+ 	PGAutonomousXACT * currentautox = NULL;
+ 
  
  	/* Get data needed for commit record */
  	nrels = smgrGetPendingDeletes(true, &rels);
  	nchildren = xactGetCommittedChildren(&children);
  	if (XLogStandbyInfoActive())
  		nmsgs = xactGetCommittedInvalidationMessages(&invalMessages,
! 													 &RelcacheInitFileInval,
! 													 isAutoXact);
  	wrote_xlog = (XactLastRecEnd != 0);
  
  	/*
***************
*** 1039,1045 **** RecordTransactionCommit(void)
  		 * assigned is a sequence advance record due to nextval() --- we want
  		 * to flush that to disk before reporting commit.)
  		 */
! 		if (!wrote_xlog)
  			goto cleanup;
  	}
  	else
--- 1116,1122 ----
  		 * assigned is a sequence advance record due to nextval() --- we want
  		 * to flush that to disk before reporting commit.)
  		 */
! 		if (!wrote_xlog || isAutoXact)
  			goto cleanup;
  	}
  	else
***************
*** 1068,1074 **** RecordTransactionCommit(void)
  		 * a bit fuzzy, but it doesn't matter.
  		 */
  		START_CRIT_SECTION();
! 		MyPgXact->delayChkpt = true;
  
  		SetCurrentTransactionStopTimestamp();
  
--- 1145,1159 ----
  		 * a bit fuzzy, but it doesn't matter.
  		 */
  		START_CRIT_SECTION();
! 		if(isAutoXact)
! 		{
! 			currentautox = GetCurrentPGAutonomousXACT();
! 			currentautox->delayChkpt = true;
! 		}
! 		else
! 		{
! 			MyPgXact->delayChkpt = true;
! 		}
  
  		SetCurrentTransactionStopTimestamp();
  
***************
*** 1229,1240 **** RecordTransactionCommit(void)
  	 */
  	if (markXidCommitted)
  	{
! 		MyPgXact->delayChkpt = false;
  		END_CRIT_SECTION();
  	}
  
  	/* Compute latestXid while we have the child XIDs handy */
  	latestXid = TransactionIdLatest(xid, nchildren, children);
  
  	/*
  	 * Wait for synchronous replication, if required.
--- 1314,1335 ----
  	 */
  	if (markXidCommitted)
  	{
! 		if(isAutoXact)
! 		{
! 			currentautox = GetCurrentPGAutonomousXACT();
! 			currentautox->delayChkpt = false;
! 		}
! 		else
! 		{
! 			MyPgXact->delayChkpt = false;
! 		}
  		END_CRIT_SECTION();
  	}
  
  	/* Compute latestXid while we have the child XIDs handy */
  	latestXid = TransactionIdLatest(xid, nchildren, children);
+ 	if (isAutoXact)
+ 		XidCacheRemoveAutoRunningXids(xid, nchildren, children, latestXid, true);
  
  	/*
  	 * Wait for synchronous replication, if required.
***************
*** 1246,1252 **** RecordTransactionCommit(void)
  		SyncRepWaitForLSN(XactLastRecEnd);
  
  	/* Reset XactLastRecEnd until the next transaction writes something */
! 	XactLastRecEnd = 0;
  
  cleanup:
  	/* Clean up local data */
--- 1341,1348 ----
  		SyncRepWaitForLSN(XactLastRecEnd);
  
  	/* Reset XactLastRecEnd until the next transaction writes something */
! 	if (!isAutoXact)
! 		XactLastRecEnd = 0;
  
  cleanup:
  	/* Clean up local data */
***************
*** 1542,1552 **** RecordTransactionAbort(bool isSubXact)
  	 * subxacts, because we already have the child XID array at hand.  For
  	 * main xacts, the equivalent happens just after this function returns.
  	 */
! 	if (isSubXact)
! 		XidCacheRemoveRunningXids(xid, nchildren, children, latestXid);
  
  	/* Reset XactLastRecEnd until the next transaction writes something */
! 	if (!isSubXact)
  		XactLastRecEnd = 0;
  
  	/* And clean up local data */
--- 1638,1679 ----
  	 * subxacts, because we already have the child XID array at hand.  For
  	 * main xacts, the equivalent happens just after this function returns.
  	 */
! 	{
! 		uint8     isAutoTX = MyProc->inAutoTXLevel;
! 		PGAutonomousXACT *currentautox = NULL;
! 
! 		int	     autoNestingLevel = 0;
! 		int	     stateNestingLevel = CurrentTransactionState->nestingLevel;
! 
! 		if (isSubXact)
! 		{
! 			if (isAutoTX)
! 			{
! 				currentautox = GetCurrentPGAutonomousXACT();
! 				autoNestingLevel = currentautox->nestingLevel;
! 
! 				if(stateNestingLevel == autoNestingLevel)
! 				{
! 					/* the top of auto TX */
! 					XidCacheRemoveAutoRunningXids(xid, nchildren, children,
! 															latestXid, true);
! 				}
! 				else
! 				{
! 					/* sub TX in auto TX */
! 					XidCacheRemoveAutoRunningXids(xid, nchildren, children,
! 															latestXid, false);
! 				}
! 			}
! 			else
! 			{
! 				XidCacheRemoveRunningXids(xid, nchildren, children, latestXid);
! 			}
! 		}
! 	}
  
  	/* Reset XactLastRecEnd until the next transaction writes something */
! 	if (!isSubXact )
  		XactLastRecEnd = 0;
  
  	/* And clean up local data */
***************
*** 1945,1951 **** CommitTransaction(void)
  	/*
  	 * Here is where we really truly commit.
  	 */
! 	latestXid = RecordTransactionCommit();
  
  	TRACE_POSTGRESQL_TRANSACTION_COMMIT(MyProc->lxid);
  
--- 2072,2078 ----
  	/*
  	 * Here is where we really truly commit.
  	 */
! 	latestXid = RecordTransactionCommit(false);
  
  	TRACE_POSTGRESQL_TRANSACTION_COMMIT(MyProc->lxid);
  
***************
*** 2525,2530 **** StartTransactionCommand(void)
--- 2652,2658 ----
  			 */
  		case TBLOCK_INPROGRESS:
  		case TBLOCK_SUBINPROGRESS:
+ 		case TBLOCK_AUTOINPROGRESS:
  			break;
  
  			/*
***************
*** 2537,2542 **** StartTransactionCommand(void)
--- 2665,2671 ----
  			 */
  		case TBLOCK_ABORT:
  		case TBLOCK_SUBABORT:
+ 		case TBLOCK_AUTOABORT:
  			break;
  
  			/* These cases are invalid. */
***************
*** 2553,2558 **** StartTransactionCommand(void)
--- 2682,2691 ----
  		case TBLOCK_SUBRESTART:
  		case TBLOCK_SUBABORT_RESTART:
  		case TBLOCK_PREPARE:
+ 		case TBLOCK_AUTOBEGIN:
+ 		case TBLOCK_AUTOCOMMIT:
+ 		case TBLOCK_AUTOABORT_PENDING:
+ 		case TBLOCK_AUTOABORT_END:
  			elog(ERROR, "StartTransactionCommand: unexpected state %s",
  				 BlockStateAsString(s->blockState));
  			break;
***************
*** 2688,2694 **** CommitTransactionCommand(void)
  			} while (s->blockState == TBLOCK_SUBRELEASE);
  
  			Assert(s->blockState == TBLOCK_INPROGRESS ||
! 				   s->blockState == TBLOCK_SUBINPROGRESS);
  			break;
  
  			/*
--- 2821,2828 ----
  			} while (s->blockState == TBLOCK_SUBRELEASE);
  
  			Assert(s->blockState == TBLOCK_INPROGRESS ||
! 				   s->blockState == TBLOCK_SUBINPROGRESS ||
! 				   s->blockState == TBLOCK_AUTOINPROGRESS);
  			break;
  
  			/*
***************
*** 2719,2724 **** CommitTransactionCommand(void)
--- 2853,2863 ----
  				PrepareTransaction();
  				s->blockState = TBLOCK_DEFAULT;
  			}
+ 			else if (s->blockState == TBLOCK_AUTOCOMMIT)
+ 			{
+ 				Assert(s->parent != NULL);
+ 				CommitAutonomousTransaction();
+ 			}
  			else
  				elog(ERROR, "CommitTransactionCommand: unexpected state %s",
  					 BlockStateAsString(s->blockState));
***************
*** 2800,2805 **** CommitTransactionCommand(void)
--- 2939,2968 ----
  				s->blockState = TBLOCK_SUBINPROGRESS;
  			}
  			break;
+ 		case TBLOCK_AUTOBEGIN:
+ 			BeginAutonomousTransaction();
+ 			s->blockState = TBLOCK_AUTOINPROGRESS;
+ 			break;
+ 
+ 		case TBLOCK_AUTOCOMMIT:
+ 			CommitAutonomousTransaction();
+ 			break;
+ 
+ 		case TBLOCK_AUTOABORT:
+ 			break;
+ 
+ 		case TBLOCK_AUTOABORT_PENDING:
+ 			AbortAutonomousTransaction();
+ 			CleanupSubTransaction();
+ 			break;
+ 
+ 		case TBLOCK_AUTOINPROGRESS:
+ 			CommandCounterIncrement();
+ 			break;
+ 
+ 		case TBLOCK_AUTOABORT_END:
+ 			CleanupSubTransaction();
+ 			break;
  	}
  }
  
***************
*** 2886,2891 **** AbortCurrentTransaction(void)
--- 3049,3055 ----
  			 */
  		case TBLOCK_ABORT:
  		case TBLOCK_SUBABORT:
+ 		case TBLOCK_AUTOABORT:
  			break;
  
  			/*
***************
*** 2952,2957 **** AbortCurrentTransaction(void)
--- 3116,3137 ----
  			CleanupSubTransaction();
  			AbortCurrentTransaction();
  			break;
+ 		case 	TBLOCK_AUTOBEGIN:
+ 		case 	TBLOCK_AUTOCOMMIT:
+ 		case 	TBLOCK_AUTOABORT_PENDING:
+ 			AbortAutonomousTransaction();
+ 			CleanupSubTransaction();
+ 			break;
+ 
+ 		case 	TBLOCK_AUTOINPROGRESS:
+ 			AbortAutonomousTransaction();
+ 			s->blockState = TBLOCK_AUTOABORT;
+ 			break;
+ 
+ 
+ 		case 	TBLOCK_AUTOABORT_END:
+ 			CleanupSubTransaction();
+ 			break;
  	}
  }
  
***************
*** 3255,3260 **** BeginTransactionBlock(void)
--- 3435,3442 ----
  		case TBLOCK_SUBINPROGRESS:
  		case TBLOCK_ABORT:
  		case TBLOCK_SUBABORT:
+ 		case TBLOCK_AUTOINPROGRESS:
+ 		case TBLOCK_AUTOABORT:
  			ereport(WARNING,
  					(errcode(ERRCODE_ACTIVE_SQL_TRANSACTION),
  					 errmsg("there is already a transaction in progress")));
***************
*** 3274,3279 **** BeginTransactionBlock(void)
--- 3456,3465 ----
  		case TBLOCK_SUBRESTART:
  		case TBLOCK_SUBABORT_RESTART:
  		case TBLOCK_PREPARE:
+ 		case TBLOCK_AUTOBEGIN:
+ 		case TBLOCK_AUTOCOMMIT:
+ 		case TBLOCK_AUTOABORT_PENDING:
+ 		case TBLOCK_AUTOABORT_END:
  			elog(FATAL, "BeginTransactionBlock: unexpected state %s",
  				 BlockStateAsString(s->blockState));
  			break;
***************
*** 3298,3303 **** PrepareTransactionBlock(char *gid)
--- 3484,3494 ----
  	TransactionState s;
  	bool		result;
  
+ 	if(MyProc->inAutoTXLevel)
+ 	{
+ 		elog(ERROR, "Can't support twophase transaction in autonomous transaction.");
+ 	}
+ 
  	/* Set up to commit the current transaction */
  	result = EndTransactionBlock();
  
***************
*** 3373,3379 **** EndTransactionBlock(void)
  			 * open subtransactions and then commit the main transaction.
  			 */
  		case TBLOCK_SUBINPROGRESS:
! 			while (s->parent != NULL)
  			{
  				if (s->blockState == TBLOCK_SUBINPROGRESS)
  					s->blockState = TBLOCK_SUBCOMMIT;
--- 3564,3570 ----
  			 * open subtransactions and then commit the main transaction.
  			 */
  		case TBLOCK_SUBINPROGRESS:
! 			while (s->parent != NULL && !IS_TOP_AUTO_TX_STATE(s))
  			{
  				if (s->blockState == TBLOCK_SUBINPROGRESS)
  					s->blockState = TBLOCK_SUBCOMMIT;
***************
*** 3384,3389 **** EndTransactionBlock(void)
--- 3575,3583 ----
  			}
  			if (s->blockState == TBLOCK_INPROGRESS)
  				s->blockState = TBLOCK_END;
+ 			else if(s->blockState == TBLOCK_AUTOINPROGRESS)
+ 				s->blockState = TBLOCK_AUTOCOMMIT;
+ 
  			else
  				elog(FATAL, "EndTransactionBlock: unexpected state %s",
  					 BlockStateAsString(s->blockState));
***************
*** 3396,3402 **** EndTransactionBlock(void)
  			 * transaction.
  			 */
  		case TBLOCK_SUBABORT:
! 			while (s->parent != NULL)
  			{
  				if (s->blockState == TBLOCK_SUBINPROGRESS)
  					s->blockState = TBLOCK_SUBABORT_PENDING;
--- 3590,3596 ----
  			 * transaction.
  			 */
  		case TBLOCK_SUBABORT:
! 			while (s->parent != NULL && !IS_TOP_AUTO_TX_STATE(s))
  			{
  				if (s->blockState == TBLOCK_SUBINPROGRESS)
  					s->blockState = TBLOCK_SUBABORT_PENDING;
***************
*** 3411,3416 **** EndTransactionBlock(void)
--- 3605,3615 ----
  				s->blockState = TBLOCK_ABORT_PENDING;
  			else if (s->blockState == TBLOCK_ABORT)
  				s->blockState = TBLOCK_ABORT_END;
+ 			else if(s->blockState == TBLOCK_AUTOINPROGRESS)
+ 				s->blockState = TBLOCK_AUTOABORT_PENDING;
+ 			else if(s->blockState == TBLOCK_AUTOABORT)
+ 				s->blockState = TBLOCK_AUTOABORT_END;
+ 
  			else
  				elog(FATAL, "EndTransactionBlock: unexpected state %s",
  					 BlockStateAsString(s->blockState));
***************
*** 3429,3434 **** EndTransactionBlock(void)
--- 3628,3642 ----
  			result = true;
  			break;
  
+ 		case TBLOCK_AUTOABORT:
+ 			s->blockState = TBLOCK_AUTOABORT_END;
+ 			break;
+ 
+ 		case TBLOCK_AUTOINPROGRESS:
+ 			s->blockState = TBLOCK_AUTOCOMMIT;
+ 			result = true;
+ 			break;
+ 
  			/* These cases are invalid. */
  		case TBLOCK_DEFAULT:
  		case TBLOCK_BEGIN:
***************
*** 3443,3448 **** EndTransactionBlock(void)
--- 3651,3660 ----
  		case TBLOCK_SUBRESTART:
  		case TBLOCK_SUBABORT_RESTART:
  		case TBLOCK_PREPARE:
+ 		case TBLOCK_AUTOBEGIN:
+ 		case TBLOCK_AUTOCOMMIT:
+ 		case TBLOCK_AUTOABORT_END:
+ 		case TBLOCK_AUTOABORT_PENDING:
  			elog(FATAL, "EndTransactionBlock: unexpected state %s",
  				 BlockStateAsString(s->blockState));
  			break;
***************
*** 3489,3495 **** UserAbortTransactionBlock(void)
  			 */
  		case TBLOCK_SUBINPROGRESS:
  		case TBLOCK_SUBABORT:
! 			while (s->parent != NULL)
  			{
  				if (s->blockState == TBLOCK_SUBINPROGRESS)
  					s->blockState = TBLOCK_SUBABORT_PENDING;
--- 3701,3707 ----
  			 */
  		case TBLOCK_SUBINPROGRESS:
  		case TBLOCK_SUBABORT:
! 			while (s->parent != NULL && !IS_TOP_AUTO_TX_STATE(s))
  			{
  				if (s->blockState == TBLOCK_SUBINPROGRESS)
  					s->blockState = TBLOCK_SUBABORT_PENDING;
***************
*** 3504,3509 **** UserAbortTransactionBlock(void)
--- 3716,3726 ----
  				s->blockState = TBLOCK_ABORT_PENDING;
  			else if (s->blockState == TBLOCK_ABORT)
  				s->blockState = TBLOCK_ABORT_END;
+ 			else if(s->blockState == TBLOCK_AUTOINPROGRESS)
+ 				s->blockState = TBLOCK_AUTOABORT_PENDING;
+ 			else if(s->blockState == TBLOCK_AUTOABORT)
+ 				s->blockState = TBLOCK_AUTOABORT_END;
+ 
  			else
  				elog(FATAL, "UserAbortTransactionBlock: unexpected state %s",
  					 BlockStateAsString(s->blockState));
***************
*** 3521,3526 **** UserAbortTransactionBlock(void)
--- 3738,3750 ----
  					 errmsg("there is no transaction in progress")));
  			s->blockState = TBLOCK_ABORT_PENDING;
  			break;
+ 		case TBLOCK_AUTOABORT:
+ 			s->blockState = TBLOCK_AUTOABORT_END;
+ 			break;
+ 
+ 		case TBLOCK_AUTOINPROGRESS:
+ 			s->blockState = TBLOCK_AUTOABORT_PENDING;
+ 			break;
  
  			/* These cases are invalid. */
  		case TBLOCK_DEFAULT:
***************
*** 3536,3541 **** UserAbortTransactionBlock(void)
--- 3760,3769 ----
  		case TBLOCK_SUBRESTART:
  		case TBLOCK_SUBABORT_RESTART:
  		case TBLOCK_PREPARE:
+ 		case TBLOCK_AUTOBEGIN:
+ 		case TBLOCK_AUTOABORT_PENDING:
+ 		case TBLOCK_AUTOABORT_END:
+ 		case TBLOCK_AUTOCOMMIT:
  			elog(FATAL, "UserAbortTransactionBlock: unexpected state %s",
  				 BlockStateAsString(s->blockState));
  			break;
***************
*** 3555,3563 **** DefineSavepoint(char *name)
  	{
  		case TBLOCK_INPROGRESS:
  		case TBLOCK_SUBINPROGRESS:
  			/* Normal subtransaction start */
! 			PushTransaction();
! 			s = CurrentTransactionState;		/* changed by push */
  
  			/*
  			 * Savepoint names, like the TransactionState block itself, live
--- 3783,3793 ----
  	{
  		case TBLOCK_INPROGRESS:
  		case TBLOCK_SUBINPROGRESS:
+ 		case TBLOCK_AUTOINPROGRESS:
  			/* Normal subtransaction start */
! 			PushTransaction(false);
! 
!  			s = CurrentTransactionState;		/* changed by push */
  
  			/*
  			 * Savepoint names, like the TransactionState block itself, live
***************
*** 3584,3589 **** DefineSavepoint(char *name)
--- 3814,3824 ----
  		case TBLOCK_SUBRESTART:
  		case TBLOCK_SUBABORT_RESTART:
  		case TBLOCK_PREPARE:
+ 		case TBLOCK_AUTOBEGIN:
+ 		case TBLOCK_AUTOCOMMIT:
+ 		case TBLOCK_AUTOABORT:
+ 		case TBLOCK_AUTOABORT_PENDING:
+ 		case TBLOCK_AUTOABORT_END:
  			elog(FATAL, "DefineSavepoint: unexpected state %s",
  				 BlockStateAsString(s->blockState));
  			break;
***************
*** 3612,3617 **** ReleaseSavepoint(List *options)
--- 3847,3854 ----
  			 * defined.
  			 */
  		case TBLOCK_INPROGRESS:
+ 		case TBLOCK_AUTOINPROGRESS:
+ 
  			ereport(ERROR,
  					(errcode(ERRCODE_S_E_INVALID_SPECIFICATION),
  					 errmsg("no such savepoint")));
***************
*** 3641,3646 **** ReleaseSavepoint(List *options)
--- 3878,3889 ----
  		case TBLOCK_SUBRESTART:
  		case TBLOCK_SUBABORT_RESTART:
  		case TBLOCK_PREPARE:
+ 		case TBLOCK_AUTOBEGIN:
+ 		case TBLOCK_AUTOCOMMIT:
+ 		case TBLOCK_AUTOABORT:
+ 		case TBLOCK_AUTOABORT_PENDING:
+ 		case TBLOCK_AUTOABORT_END:
+ 
  			elog(FATAL, "ReleaseSavepoint: unexpected state %s",
  				 BlockStateAsString(s->blockState));
  			break;
***************
*** 3656,3668 **** ReleaseSavepoint(List *options)
  
  	Assert(PointerIsValid(name));
  
! 	for (target = s; PointerIsValid(target); target = target->parent)
  	{
  		if (PointerIsValid(target->name) && strcmp(target->name, name) == 0)
  			break;
  	}
  
! 	if (!PointerIsValid(target))
  		ereport(ERROR,
  				(errcode(ERRCODE_S_E_INVALID_SPECIFICATION),
  				 errmsg("no such savepoint")));
--- 3899,3911 ----
  
  	Assert(PointerIsValid(name));
  
! 	for (target = s; PointerIsValid(target) && !IS_TOP_AUTO_TX_STATE(target); target = target->parent)
  	{
  		if (PointerIsValid(target->name) && strcmp(target->name, name) == 0)
  			break;
  	}
  
! 	if (!PointerIsValid(target) || (IS_TOP_AUTO_TX_STATE(target) && target->name == NULL))
  		ereport(ERROR,
  				(errcode(ERRCODE_S_E_INVALID_SPECIFICATION),
  				 errmsg("no such savepoint")));
***************
*** 3713,3718 **** RollbackToSavepoint(List *options)
--- 3956,3964 ----
  			 */
  		case TBLOCK_INPROGRESS:
  		case TBLOCK_ABORT:
+ 		case TBLOCK_AUTOINPROGRESS:
+ 		case TBLOCK_AUTOABORT:
+ 
  			ereport(ERROR,
  					(errcode(ERRCODE_S_E_INVALID_SPECIFICATION),
  					 errmsg("no such savepoint")));
***************
*** 3740,3745 **** RollbackToSavepoint(List *options)
--- 3986,3995 ----
  		case TBLOCK_SUBRESTART:
  		case TBLOCK_SUBABORT_RESTART:
  		case TBLOCK_PREPARE:
+ 		case TBLOCK_AUTOBEGIN:
+ 		case TBLOCK_AUTOCOMMIT:
+ 		case TBLOCK_AUTOABORT_PENDING:
+ 		case TBLOCK_AUTOABORT_END:
  			elog(FATAL, "RollbackToSavepoint: unexpected state %s",
  				 BlockStateAsString(s->blockState));
  			break;
***************
*** 3755,3767 **** RollbackToSavepoint(List *options)
  
  	Assert(PointerIsValid(name));
  
! 	for (target = s; PointerIsValid(target); target = target->parent)
  	{
  		if (PointerIsValid(target->name) && strcmp(target->name, name) == 0)
  			break;
  	}
  
! 	if (!PointerIsValid(target))
  		ereport(ERROR,
  				(errcode(ERRCODE_S_E_INVALID_SPECIFICATION),
  				 errmsg("no such savepoint")));
--- 4005,4017 ----
  
  	Assert(PointerIsValid(name));
  
! 	for (target = s; PointerIsValid(target) && !IS_TOP_AUTO_TX_STATE(target); target = target->parent)
  	{
  		if (PointerIsValid(target->name) && strcmp(target->name, name) == 0)
  			break;
  	}
  
! 	if (!PointerIsValid(target)||(IS_TOP_AUTO_TX_STATE(target)&& target->name == NULL))
  		ereport(ERROR,
  				(errcode(ERRCODE_S_E_INVALID_SPECIFICATION),
  				 errmsg("no such savepoint")));
***************
*** 3824,3831 **** BeginInternalSubTransaction(char *name)
  		case TBLOCK_END:
  		case TBLOCK_PREPARE:
  		case TBLOCK_SUBINPROGRESS:
  			/* Normal subtransaction start */
! 			PushTransaction();
  			s = CurrentTransactionState;		/* changed by push */
  
  			/*
--- 4074,4082 ----
  		case TBLOCK_END:
  		case TBLOCK_PREPARE:
  		case TBLOCK_SUBINPROGRESS:
+ 		case TBLOCK_AUTOINPROGRESS:
  			/* Normal subtransaction start */
! 			PushTransaction(false);
  			s = CurrentTransactionState;		/* changed by push */
  
  			/*
***************
*** 3850,3855 **** BeginInternalSubTransaction(char *name)
--- 4101,4111 ----
  		case TBLOCK_SUBABORT_PENDING:
  		case TBLOCK_SUBRESTART:
  		case TBLOCK_SUBABORT_RESTART:
+ 		case TBLOCK_AUTOBEGIN:
+ 		case TBLOCK_AUTOCOMMIT:
+ 		case TBLOCK_AUTOABORT:
+ 		case TBLOCK_AUTOABORT_END:
+ 		case TBLOCK_AUTOABORT_PENDING:
  			elog(FATAL, "BeginInternalSubTransaction: unexpected state %s",
  				 BlockStateAsString(s->blockState));
  			break;
***************
*** 3917,3922 **** RollbackAndReleaseCurrentSubTransaction(void)
--- 4173,4184 ----
  		case TBLOCK_SUBRESTART:
  		case TBLOCK_SUBABORT_RESTART:
  		case TBLOCK_PREPARE:
+ 		case TBLOCK_AUTOINPROGRESS:
+ 		case TBLOCK_AUTOBEGIN:
+ 		case TBLOCK_AUTOCOMMIT:
+ 		case TBLOCK_AUTOABORT:
+ 		case TBLOCK_AUTOABORT_END:
+ 		case TBLOCK_AUTOABORT_PENDING:
  			elog(FATAL, "RollbackAndReleaseCurrentSubTransaction: unexpected state %s",
  				 BlockStateAsString(s->blockState));
  			break;
***************
*** 4015,4020 **** AbortOutOfAnyTransaction(void)
--- 4277,4297 ----
  				CleanupSubTransaction();
  				s = CurrentTransactionState;	/* changed by pop */
  				break;
+ 			case TBLOCK_AUTOBEGIN:
+ 			case TBLOCK_AUTOINPROGRESS:
+ 			case TBLOCK_AUTOCOMMIT:
+ 			case TBLOCK_AUTOABORT_PENDING:
+ 				AbortAutonomousTransaction();
+ 				CleanupSubTransaction();
+ 				s = CurrentTransactionState;	/* changed by pop */
+ 				break;
+ 
+ 			case TBLOCK_AUTOABORT:
+ 			case TBLOCK_AUTOABORT_END:
+ 				/* As above, but AbortSubTransaction already done */
+ 				CleanupSubTransaction();
+ 				s = CurrentTransactionState;	/* changed by pop */
+ 				break;
  		}
  	} while (s->blockState != TBLOCK_DEFAULT);
  
***************
*** 4075,4080 **** TransactionBlockStatusCode(void)
--- 4352,4360 ----
  		case TBLOCK_SUBRELEASE:
  		case TBLOCK_SUBCOMMIT:
  		case TBLOCK_PREPARE:
+ 		case TBLOCK_AUTOBEGIN:
+ 		case TBLOCK_AUTOCOMMIT:
+ 		case TBLOCK_AUTOINPROGRESS:
  			return 'T';			/* in transaction */
  		case TBLOCK_ABORT:
  		case TBLOCK_SUBABORT:
***************
*** 4084,4089 **** TransactionBlockStatusCode(void)
--- 4364,4372 ----
  		case TBLOCK_SUBABORT_PENDING:
  		case TBLOCK_SUBRESTART:
  		case TBLOCK_SUBABORT_RESTART:
+ 		case TBLOCK_AUTOABORT:
+ 		case TBLOCK_AUTOABORT_PENDING:
+ 		case TBLOCK_AUTOABORT_END:
  			return 'E';			/* in failed transaction */
  	}
  
***************
*** 4398,4404 **** CleanupSubTransaction(void)
  
  	ShowTransactionState("CleanupSubTransaction");
  
! 	if (s->state != TRANS_ABORT)
  		elog(WARNING, "CleanupSubTransaction while in %s state",
  			 TransStateAsString(s->state));
  
--- 4681,4687 ----
  
  	ShowTransactionState("CleanupSubTransaction");
  
! 	if (s->state != TRANS_ABORT && !IS_TOP_AUTO_TX_STATE(s))
  		elog(WARNING, "CleanupSubTransaction while in %s state",
  			 TransStateAsString(s->state));
  
***************
*** 4425,4434 **** CleanupSubTransaction(void)
   *	if it has a local pointer to it after calling this function.
   */
  static void
! PushTransaction(void)
  {
  	TransactionState p = CurrentTransactionState;
  	TransactionState s;
  
  	/*
  	 * We keep subtransaction state nodes in TopTransactionContext.
--- 4708,4718 ----
   *	if it has a local pointer to it after calling this function.
   */
  static void
! PushTransaction(bool isAutoTX)
  {
  	TransactionState p = CurrentTransactionState;
  	TransactionState s;
+ 	PGAutonomousXACT *currentautotx = NULL;
  
  	/*
  	 * We keep subtransaction state nodes in TopTransactionContext.
***************
*** 4461,4470 **** PushTransaction(void)
  	s->gucNestLevel = NewGUCNestLevel();
  	s->savepointLevel = p->savepointLevel;
  	s->state = TRANS_DEFAULT;
- 	s->blockState = TBLOCK_SUBBEGIN;
  	GetUserIdAndSecContext(&s->prevUser, &s->prevSecContext);
  	s->prevXactReadOnly = XactReadOnly;
  
  	CurrentTransactionState = s;
  
  	/*
--- 4745,4766 ----
  	s->gucNestLevel = NewGUCNestLevel();
  	s->savepointLevel = p->savepointLevel;
  	s->state = TRANS_DEFAULT;
  	GetUserIdAndSecContext(&s->prevUser, &s->prevSecContext);
  	s->prevXactReadOnly = XactReadOnly;
  
+ 	if (isAutoTX)
+ 	{
+ 		MyProc->inAutoTXLevel++;
+ 		currentautotx = GetCurrentPGAutonomousXACT();
+ 		currentautotx->nestingLevel = s->nestingLevel;
+ 		s->blockState = TBLOCK_AUTOBEGIN;
+ 	}
+ 	else
+ 	{
+ 		s->blockState = TBLOCK_SUBBEGIN;
+ 	}
+ 
+ 
  	CurrentTransactionState = s;
  
  	/*
***************
*** 4486,4491 **** static void
--- 4782,4788 ----
  PopTransaction(void)
  {
  	TransactionState s = CurrentTransactionState;
+ 	PGAutonomousXACT *currentautox = NULL;
  
  	if (s->state != TRANS_DEFAULT)
  		elog(WARNING, "PopTransaction while in %s state",
***************
*** 4504,4509 **** PopTransaction(void)
--- 4801,4815 ----
  	CurTransactionResourceOwner = s->parent->curTransactionOwner;
  	CurrentResourceOwner = s->parent->curTransactionOwner;
  
+ 	if(IS_TOP_AUTO_TX_STATE(s))
+ 	{
+ 		currentautox = GetCurrentPGAutonomousXACT();
+ 	/*lint -e506 -e681  */
+ 		MemSet(currentautox, 0, sizeof(PGAutonomousXACT));
+ 	/*lint +e506 +e681  */
+ 		MyProc->inAutoTXLevel--;
+ 	}
+ 
  	/* Free the old child structure */
  	if (s->name)
  		pfree(s->name);
